//----------------------------------------------------------------------------
//  Project FastMode
//  
//  Copyright _ 1997. All Rights Reserved.
//
//  SUBSYSTEM:    FastMode Application
//  FILE:         fastmodeapp.h
//  AUTHOR:       
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TFastModeApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(fastmodeapp_h)              // Sentry, use file only if it's not already included.
#define fastmodeapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/opensave.h>


#include "fastmodeapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TFastModeAppVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TFastModeAppVIRTUAL_END}}
};    //{{TSDIDecFrame}}


//{{TApplication = TFastModeApp}}
class TFastModeApp : public TApplication {
  private:

    void ProcessCmdLine(char * CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TFastModeApp();
    virtual ~TFastModeApp();

    THarbor*        ApxHarbor;

//{{TFastModeAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TFastModeAppVIRTUAL_END}}

//{{TFastModeAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TFastModeAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TFastModeApp);
};    //{{TFastModeApp}}


#endif  // fastmodeapp_h sentry.
