//----------------------------------------------------------------------------
//  Project LPTPort
//  Zeal SoftStudio
//  Copyright (c) 1997-2002, Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    LPTPort Application
//  FILE:         lptportapp.cpp
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TLPTPortApp (TApplication).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include <owl/buttonga.h>
#include <owl/statusba.h>
#include <classlib/cmdline.h>
#include <winsys/registry.h>
#include <stdio.h>

#include "lptportapp.h"
#include "lptportdlgclient.h"                        // Definition of client class.


//{{TLPTPortApp Implementation}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TLPTPortApp, TApplication)
//{{TLPTPortAppRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{TLPTPortAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TLPTPortApp
//
TLPTPortApp::TLPTPortApp() : TApplication("LPTPort Sample")
{

  // INSERT>> Your constructor code here.
}


TLPTPortApp::~TLPTPortApp()
{
  // INSERT>> Your destructor code here.
}


//--------------------------------------------------------
// TLPTPortApp
// ~~~~~
// Application intialization.
//
void TLPTPortApp::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, true);
  frame->SetFlag(wfShrinkToClient);

  // Override the default window style for the main window.
  //
      frame->Attr.Style |= WS_BORDER | WS_CAPTION | WS_CLIPCHILDREN | WS_SYSMENU | WS_THICKFRAME | WS_VISIBLE;
    frame->Attr.Style &= ~(WS_CHILD | WS_MAXIMIZEBOX | WS_MINIMIZEBOX);

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  SetMainWindow(frame);

}


//--------------------------------------------------------
// TLPTPortApp
// ~~~~~
// Application instance initialization.
//
void TLPTPortApp::InitInstance()
{
  TApplication::InitInstance();

  ProcessCmdLine(lpCmdLine);
}


//--------------------------------------------------------
// TLPTPortApp
// ~~~~~
// Process command line parameters.
//
void TLPTPortApp::ProcessCmdLine(char * CmdLine)
{
  TCmdLine cmd(CmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TLPTPortApp
// ~~~~~
// Register application info.
//
void TLPTPortApp::RegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "LPTPort.Application\\DefaultIcon").SetDefValue(0, REG_SZ, buffer, strlen(buffer));
  strcat(buffer, ",1");
}


//--------------------------------------------------------
// TLPTPortApp
// ~~~~~
// Unregister application info.
//
void TLPTPortApp::UnRegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "LPTPort.Application").DeleteKey("DefaultIcon");
  TRegKey(TRegKey::ClassesRoot, "LPTPort.Document.1").DeleteKey("DefaultIcon");

  TRegKey::ClassesRoot.DeleteKey("LPTPort.Application");
}



//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TLPTPortDlgClient(0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}


void TSDIDecFrame::SetupWindow()
{
  TDecoratedFrame::SetupWindow();
  TRect  r;
  GetWindowRect(r);

  r.bottom += 30;
  SetWindowPos(0, r, SWP_NOZORDER | SWP_NOMOVE);

  // INSERT>> Your code here.

}


//--------------------------------------------------------
// TLPTPortApp
// ~~~~~~~~~~~
// Menu Help About LPTPort command
//
void TLPTPortApp::CmHelpAbout()
{
}



int OwlMain(int , char* [])
{
  TLPTPortApp   app;
  return app.Run();
}
