//----------------------------------------------------------------------------
//  Project LPTPort
//  Zeal SoftStudio
//  Copyright (c) 1997-2002, Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    LPTPort Application
//  FILE:         lptportapp.h
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TLPTPortApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(lptportapp_h)              // Sentry, use file only if it's not already included.
#define lptportapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/opensave.h>


#include "lptportapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TLPTPortAppVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TLPTPortAppVIRTUAL_END}}
};    //{{TSDIDecFrame}}


//{{TApplication = TLPTPortApp}}
class TLPTPortApp : public TApplication {
  private:

    void ProcessCmdLine(char * CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TLPTPortApp();
    virtual ~TLPTPortApp();

    THarbor*        ApxHarbor;

//{{TLPTPortAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TLPTPortAppVIRTUAL_END}}

//{{TLPTPortAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TLPTPortAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TLPTPortApp);
};    //{{TLPTPortApp}}


#endif  // lptportapp_h sentry.
