//----------------------------------------------------------------------------
//  Project LPTPort
//  Zeal SoftStudio
//  Copyright (c) 1997-2002, Zeal SoftStudio. All Rights Reserved.
//  E-Mail: support@zealsoftstudio.com
//  Web: http://www.zealsoftstudio.com
//  This sample illustrates how to use NTPort Library
//  to get LPT ports address.
//
//  SUBSYSTEM:    LPTPort Application
//  FILE:         lptportdlgclient.cpp
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TLPTPortDlgClient (TDialog).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include "lptportapp.h"
#include "lptportdlgclient.h"
#include "ntport.h"

//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(TLPTPortDlgClient, TDialog)
//{{TLPTPortDlgClientRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDOK, BNClicked),
//{{TLPTPortDlgClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TLPTPortDlgClient Implementation}}


//--------------------------------------------------------
// TLPTPortDlgClient
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TLPTPortDlgClient::TLPTPortDlgClient(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
}


TLPTPortDlgClient::~TLPTPortDlgClient()
{
  Destroy();

  // INSERT>> Your destructor code here.
}

void TLPTPortDlgClient::BNClicked()
{
  // INSERT>> Your code here.
  int nAddress, nError;
  short i;
  char s[256];

  SendDlgItemMessage(IDC_LISTBOX1, LB_RESETCONTENT);
  for(i = 1; i <= 3; i++)
  {
      nAddress = GetLPTPortAddress(i);
      nError = GetLastState(NULL);
      if(nAddress)
            wsprintf(s, "LPT %d: %3xH", i, nAddress);
      else if(nError)
            wsprintf(s, "LPT %d: Error", i);
      else
            wsprintf(s, "LPT %d: absent", i);
		SendDlgItemMessage(IDC_LISTBOX1, LB_ADDSTRING, 0, (LPARAM)s);

  }
}

