//----------------------------------------------------------------------------
//  Project PortTest
//  Zeal SoftStudio
//  Copyright (c) 1997-2002. Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    PortTest Application
//  FILE:         porttestapp.h
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TPortTestApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(porttestapp_h)              // Sentry, use file only if it's not already included.
#define porttestapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/opensave.h>


#include "porttestapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TPortTestAppVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TPortTestAppVIRTUAL_END}}
};    //{{TSDIDecFrame}}


//{{TApplication = TPortTestApp}}
class TPortTestApp : public TApplication {
  private:

    void ProcessCmdLine(char * CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TPortTestApp();
    virtual ~TPortTestApp();

    THarbor*        ApxHarbor;

//{{TPortTestAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TPortTestAppVIRTUAL_END}}

//{{TPortTestAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TPortTestAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TPortTestApp);
};    //{{TPortTestApp}}


#endif  // porttestapp_h sentry.
