//----------------------------------------------------------------------------
//  Project PortTest
//  Zeal SoftStudio
//  Copyright (c) 1997-2002. Zeal SoftStudio. All Rights Reserved.
//  EMail: support@zealsoftstudio.com
//  Web: http://www.zealsoftstudio.com (English)
//      http://zeaslsoft.yeah.net/ (Chinese)
//  This sample illustrates how to use NTPort
//  Library to read or write PC I/O ports.
//
//  SUBSYSTEM:    PortTest Application
//  FILE:         porttestdlgclient.cpp
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TPortTestDlgClient (TDialog).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include "porttestapp.h"
#include "porttestdlgclient.h"
#include <owl/listbox.h>
#include "ntport.h"

//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(TPortTestDlgClient, TDialog)
//{{TPortTestDlgClientRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDC_READ, BNReadClicked),
  EV_BN_CLICKED(IDC_WRITE, BNWriteClicked),
//{{TPortTestDlgClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TPortTestDlgClient Implementation}}


//--------------------------------------------------------
// TPortTestDlgClient
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TPortTestDlgClient::TPortTestDlgClient(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
}


TPortTestDlgClient::~TPortTestDlgClient()
{
  Destroy();

  // INSERT>> Your destructor code here.
}

bool TPortTestDlgClient::Create()
{
  bool result;

  result = TDialog::Create();

  // INSERT>> Your code here.
  CheckDlgButton(IDC_RADIOBUTTON1, 1);

  return result;
}

int axtoi(char *hexStg)
{
  int n = 0;         // position in string
  int m;             // position in digit[] to shift
  int count;         // loop index
  int intValue = 0;  // integer value of hex string
  int digit[9];      // hold values to convert
  while (n < 8) {
     if (hexStg[n]=='\0')
        break;
     if (hexStg[n] > 0x29 && hexStg[n] < 0x40 ) //if 0 to 9
        digit[n] = hexStg[n] & 0x0f;            //convert to int
     else if (hexStg[n] >='a' && hexStg[n] <= 'f') //if a to f
        digit[n] = (hexStg[n] & 0x0f) + 9;      //convert to int
     else if (hexStg[n] >='A' && hexStg[n] <= 'F') //if A to F
        digit[n] = (hexStg[n] & 0x0f) + 9;      //convert to int
     else break;
    n++;
  }
  count = n;
  m = n - 1;
  n = 0;
  while(n < count) {
     // digit[n] is value of hex digit at position n
     // (m << 2) is the number of positions to shift
     // OR the bits into return value
     intValue = intValue | (digit[n] << (m << 2));
     m--;   // adjust the position to set
     n++;   // next digit to process
  }
  return (intValue);
}

void TPortTestDlgClient::BNReadClicked()
{
  // INSERT>> Your code here.
  int inNum;
  int portAdd;
  char sBuff[255];

  GetDlgItemText(IDC_EDITADDR, sBuff, 8);
  portAdd = axtoi(sBuff);

  if(IsDlgButtonChecked(IDC_RADIOBUTTON1)) // Byte
     inNum = Inport((WORD)portAdd);
  else if(IsDlgButtonChecked(IDC_RADIOBUTTON2)) // Word
     inNum = InportW((WORD)portAdd);
  else // Dword
     inNum = InportD((WORD)portAdd);

  wsprintf(sBuff, "In 0x%x, 0x%x", portAdd, inNum);
  SendDlgItemMessage(IDC_LISTBOX1, LB_ADDSTRING, 0, (LPARAM)sBuff);

  char sError[255];
  GetLastState(sError);
  SendDlgItemMessage(IDC_LISTBOX1, LB_ADDSTRING, 0, (LPARAM)sError);
}


void TPortTestDlgClient::BNWriteClicked()
{
  // INSERT>> Your code here.
  long outNum;
  int portAdd;
  char sBuff[255];

  GetDlgItemText(IDC_EDITADDR, sBuff, 8);
  portAdd = axtoi(sBuff);
  GetDlgItemText(IDC_EDITDATA, sBuff, 8);
  outNum = axtoi(sBuff);

  if(IsDlgButtonChecked(IDC_RADIOBUTTON1)) // Byte
     Outport((WORD)portAdd, (WORD)outNum);
  else if(IsDlgButtonChecked(IDC_RADIOBUTTON2)) // Word
     OutportW((WORD)portAdd, (WORD)outNum);
  else // Dword
     OutportD((WORD)portAdd, outNum);

  wsprintf(sBuff, "Out 0x%x, 0x%x", portAdd, outNum);
  SendDlgItemMessage(IDC_LISTBOX1, LB_ADDSTRING, 0, (LPARAM)sBuff);

  char sError[255];
  GetLastState(sError);
  SendDlgItemMessage(IDC_LISTBOX1, LB_ADDSTRING, 0, (LPARAM)sError);
}

