//----------------------------------------------------------------------------
//  Project Speaker
//  
//  Copyright _ 1997. All Rights Reserved.
//
//  SUBSYSTEM:    Speaker Application
//  FILE:         spekrapp.cpp
//  AUTHOR:       
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TSpeakerApp (TApplication).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include <owl/buttonga.h>
#include <owl/statusba.h>
#include <classlib/cmdline.h>
#include <winsys/registry.h>
#include <stdio.h>

#include "spekrapp.h"
#include "spkrdlgc.h"                        // Definition of client class.


//{{TSpeakerApp Implementation}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TSpeakerApp, TApplication)
//{{TSpeakerAppRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{TSpeakerAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TSpeakerApp
//
TSpeakerApp::TSpeakerApp() : TApplication("Speaker")
{

  // INSERT>> Your constructor code here.
}


TSpeakerApp::~TSpeakerApp()
{
  // INSERT>> Your destructor code here.
}


//--------------------------------------------------------
// TSpeakerApp
// ~~~~~
// Application intialization.
//
void TSpeakerApp::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, true);
  frame->SetFlag(wfShrinkToClient);

  // Assign icons for this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);

  SetMainWindow(frame);

}


//--------------------------------------------------------
// TSpeakerApp
// ~~~~~
// Application instance initialization.
//
void TSpeakerApp::InitInstance()
{
  TApplication::InitInstance();

  ProcessCmdLine(lpCmdLine);
}


//--------------------------------------------------------
// TSpeakerApp
// ~~~~~
// Process command line parameters.
//
void TSpeakerApp::ProcessCmdLine(char * CmdLine)
{
  TCmdLine cmd(CmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TSpeakerApp
// ~~~~~
// Register application info.
//
void TSpeakerApp::RegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "Speaker.Application\\DefaultIcon").SetDefValue(0, REG_SZ, buffer, strlen(buffer));
  strcat(buffer, ",1");
}


//--------------------------------------------------------
// TSpeakerApp
// ~~~~~
// Unregister application info.
//
void TSpeakerApp::UnRegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "Speaker.Application").DeleteKey("DefaultIcon");
  TRegKey(TRegKey::ClassesRoot, "Speaker.Document.1").DeleteKey("DefaultIcon");

  TRegKey::ClassesRoot.DeleteKey("Speaker.Application");
}



//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TSpeakerDlgClient(0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}


void TSDIDecFrame::SetupWindow()
{
  TDecoratedFrame::SetupWindow();
  TRect  r;
  GetWindowRect(r);

  r.bottom += 30;
  SetWindowPos(0, r, SWP_NOZORDER | SWP_NOMOVE);

  // INSERT>> Your code here.

}


//--------------------------------------------------------
// TSpeakerApp
// ~~~~~~~~~~~
// Menu Help About Speaker command
//
void TSpeakerApp::CmHelpAbout()
{
}



int OwlMain(int , char* [])
{
  TSpeakerApp   app;
  return app.Run();
}
