//----------------------------------------------------------------------------
//  Project Speaker
//  
//  Copyright _ 1997. All Rights Reserved.
//
//  SUBSYSTEM:    Speaker Application
//  FILE:         spekrapp.h
//  AUTHOR:       
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TSpeakerApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(spekrapp_h)              // Sentry, use file only if it's not already included.
#define spekrapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/opensave.h>


#include "spekrapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TSpeakerAppVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TSpeakerAppVIRTUAL_END}}
};    //{{TSDIDecFrame}}


//{{TApplication = TSpeakerApp}}
class TSpeakerApp : public TApplication {
  private:

    void ProcessCmdLine(char * CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TSpeakerApp();
    virtual ~TSpeakerApp();

    THarbor*        ApxHarbor;

//{{TSpeakerAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TSpeakerAppVIRTUAL_END}}

//{{TSpeakerAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TSpeakerAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TSpeakerApp);
};    //{{TSpeakerApp}}


#endif  // spekrapp_h sentry.
