//----------------------------------------------------------------------------
//  PC Speaker Sample
//
//  Copyright  1997-2002 Zeal SoftStudio.
//  EMail: support@zealsoftstudio.com
//  Web: http://www.zealsoftstudio.com (English)
//     http://zeaslsoft.yeah.net/ (Chinese)
//
//  SUBSYSTEM:    Speaker Application
//  FILE:         spkrdlgc.cpp
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  This sample illustrates how to use NTPort Library to control PC speaker.
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include "spekrapp.h"
#include "spkrdlgc.h"

#include "ntport.h"

char sz[256];

//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(TSpeakerDlgClient, TDialog)
//{{TSpeakerDlgClientRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDC_BUTTON1, BN1Clicked),
  EV_BN_CLICKED(IDC_BUTTON2, BN2Clicked),
//{{TSpeakerDlgClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TSpeakerDlgClient Implementation}}


//--------------------------------------------------------
// TSpeakerDlgClient
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TSpeakerDlgClient::TSpeakerDlgClient(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
  LicenseInfo("Your name", 0);
}


TSpeakerDlgClient::~TSpeakerDlgClient()
{
  Destroy();

  // INSERT>> Your destructor code here.
}

#define Clk8253  1193180
void setfreq(int freq)
{
  int divider;

  divider =  Clk8253 / freq;
  Outport(0x43, 0xb6);	         					// timer 2, square wave
  Outport(0x42, (short)(divider % 256));
  Outport(0x42, (short)(divider / 256));
}

void TSpeakerDlgClient::BN1Clicked()
{
  // INSERT>> Your code here.
  setfreq(GetDlgItemInt(IDC_EDIT1));
  Outport(0x61, (short)(Inport(0x61) | 0x03));  // enable speaker
  GetLastState(sz);
  SetDlgItemText(IDC_INFOTEXT, sz);
}


void TSpeakerDlgClient::BN2Clicked()
{
  // INSERT>> Your code here.
  Outport(0x61, (short)(Inport(0x61) & (0xFF - 0x03)));  // disable speaker
}

